/*--------------------------------------------------------------*/
//ֹظ
#ifndef __MAX7221_H__
#define __MAX7221_H__


/*--------------------------------------------------------------*/
//ӿڶ
sbit MAX7221_DIN = P1^0;		//
sbit MAX7221_CS  = P1^1;		//
sbit MAX7221_CLK = P1^2;		//ʱ



/*--------------------------------------------------------------*/
//ĴԼزú궨

//BCDģʽ
#define Decode_Mode		0x09		
//
#define Decode_None 	0x00		//
#define Decode_0		0x01		//ֻDigit 0
#define Decode_0_3		0x0f		//ֻDigit 0~3
#define Decode_All		0xff		//


//ʾռձȣȵ
#define Intensity		0x0a		
//0~15ʮȵ


//ʾλ
#define Scan_Limit		0x0b
//0~7ӦDigit 0~7ֻʾλ


//ʾ
#define Show_Power		0x0c
//
#define Show_Off		0x00		//ʾر
#define Show_On			0x01		//ʾ
		

//ʾԣжζ
//ע⣺Ϻ󣬱رղԣܽʾһֱΪ״̬
#define Show_Test		0x0f
//
#define Test_Off		0x00
#define	Test_On			0x01		


/*--------------------------------------------------------------*/
//Զ		   
unsigned char code seg [] = {0x7E,0x30,0x6D,0x79,0x33,0x5B,0x5F,0x70,0x7F,0x7B,0x01,0x00};
							//0,   1,   2,   3,   4,   5,   6,   7,   8,   9,   10,  blank



/*--------------------------------------------------------------*/
//MAX7221д8λ(ڲ)
void Write8_MAX7221(unsigned char dat)
{
	unsigned char i;
	for(i = 8; i > 0; i--)
	{
		MAX7221_CLK = 0;
		MAX7221_DIN = (bit)(dat & 0x80);		
		MAX7221_CLK = 1;
		dat <<= 1;
	}
}



/*--------------------------------------------------------------*/
//MAX7221ָĴַд
void Write_MAX7221(unsigned char add, unsigned char dat)
{
	MAX7221_CS = 0;
	Write8_MAX7221(add);		//дĴַ
	Write8_MAX7221(dat);		//дò
	MAX7221_CS = 1;
}


/*--------------------------------------------------------------*/
//MAX7221ʼ
void Initial_MAX7221(void)
{
	Write_MAX7221(Decode_Mode, Decode_All);	//BCD뷽ʽ8λ
	Write_MAX7221(Intensity,   0x0f);		//16ȵڣ
	Write_MAX7221(Scan_Limit,  0x07);		//ɨλ8λɨ
	Write_MAX7221(Show_Power,  Show_On);	//ʾأʾ
	Write_MAX7221(Show_Test,   Test_Off);	//ʾԣ
}


/*--------------------------------------------------------------*/
//λʾ
//ݲ
//pos:	λãӵλλΪ1-8
//dat:	֣0-9
//dot:	С㣬01С
//ͼģʽùɨλͿ0 ^_^
void DisplayP_MAX7221(unsigned char pos, unsigned char dat, bit dot)
{
	Write_MAX7221(Decode_Mode, Decode_None);//
	Write_MAX7221(Scan_Limit,  0x07);		//ɨλ8λɨ
	if(dot) dat += 128;						//С
	Write_MAX7221(pos, seg[dat]);	
}



/*--------------------------------------------------------------*/
//λʾ
//ݲ
//pos:	λãӵλλΪ1-8
//dat:	֣0-99
//ͼģʽùɨλͿ0 ^_^
void DisplayPD_MAX7221(unsigned char pos, unsigned char dat)
{
	unsigned char x,y;
	x = dat/10;
	y = dat%10;
	Write_MAX7221(Decode_Mode, Decode_None);//
	Write_MAX7221(Scan_Limit,  0x07);		//ɨλ8λɨ
	Write_MAX7221(pos,  seg[x]);
	Write_MAX7221(pos-1,seg[y]);	
}


/*--------------------------------------------------------------*/
//MAX7221ʾ鷽ʽַʽ8λ̶ʾ
void DisplayAS8_MAX7221(unsigned char *dat)
{
	unsigned char i;
	Write_MAX7221(Scan_Limit, 7);			//ɨλ8
	for(i = 0; i < 8; i++)
	{
		Write_MAX7221(i+1, *(dat+7-i));
	}
}


/*--------------------------------------------------------------*/
//ݼĴ
void ClearRam_MAX7221(unsigned char n)
{
	unsigned char i;
	for(i = n; i > 0; i--)
	Write_MAX7221(i, 0);
}


/*--------------------------------------------------------------*/
#endif 
