/*--------------------------------------------------------------*/
//File: MAX7221Ӧõ
//Date: 09-3-3
//Time: 15:58


/*--------------------------------------------------------------*/
//ͷļ
#include <REG52.H>
#include "MAX7221.H"



/*--------------------------------------------------------------*/
//̽ӿڶ
sbit k1 = P1^3;
sbit k2 = P1^4;
sbit k3 = P1^5;
sbit k4 = P1^6;				//ȵ



/*--------------------------------------------------------------*/
//ر
unsigned char count;		//50ms
unsigned char second;		//1s
unsigned char minute;		//1m
unsigned char hour;			//1h
unsigned char light;		//
unsigned char code tab[] = {0x37,0x4F,0x0E,0x0E,0x1D,0x62,0x08,0x62};

/*--------------------------------------------------------------*/
//ʱʼ
//fosc = 11.0592MHz
void T0_init(void)                    
{
    TMOD = 0x01;
    TH0  = 0x4b;                       //50000us
    TL0  = 0x06;
    IE  |= 0x82;
    TR0  = 1;
}


/*--------------------------------------------------------------*/
//ʱ100000-3us 
void delay(void)
{
    unsigned char i,j;
    for(i=232;i>0;i--)
    for(j=214;j>0;j--);
}


/*--------------------------------------------------------------*/
//
/*void Key_pro(void)
{
	static bit state1, state2, sk;

	if((k1==0)||(k2==0)||(k3==0)||(k4==0))
	{
		delay100ms();
		if((k1==0)||(k2==0)||(k3==0)||(k4==0))
		{
			if(!sk)
			{
				if(k1 == 0)
				{	
					second = 0;
					while(k1 == 0);	
				}

				if(k2 == 0)
				{	
					minute++;
					if(minute == 60)	minute = 0;
					while(k2 == 0);
				}

				if(k3 == 0)
				{			
					hour++;
					if(hour == 24)		hour = 0;	
					while(k3 == 0);	
				}
	
				if(k4 == 0)
				{
					light++;
					if(light == 16)		light = 0;
					sk = ~sk;
					while(k4 == 0);
				}
			}
		
			else
			{
				if(k2 == 0)
				{
					state1 = ~state1;
					Write_MAX7221(Show_Power,  state1);
					while(k2 == 0);
				}
				if(k3 == 0)
				{
					state2 = ~state2;
					Write_MAX7221(Show_Test,   state2);
					while(k3 == 0);
				}
				if(k4 == 0)
				{
					sk = ~sk;
					while(k4 == 0);
				}
			}			
		}
	}
}


/*--------------------------------------------------------------*/
//
/*void Key_pro(void)
{
	static	bit state;

	if(k1 == 0)
	{
		delay5ms();
		if(k1 == 0)
		{	
			second = 0;
			while(k1 == 0);	
		}
	}

	if(k2 == 0)
	{	
		delay5ms();
		if(k2 == 0)
		{
			minute++;
			if(minute == 60)	minute = 0;
			while(k2 == 0);
		}
	}

	if(k3 == 0)
	{	
		delay5ms();
		if(k3 == 0)		
		{
			hour++;
			if(hour == 24)		hour = 0;	
			while(k3 == 0);	
		}
	}
	
	if(k4 == 0)
	{
		delay5ms();
		if(k4 == 0)
		{
			light++;
			if(light == 16)		light = 0;
			while(k4 == 0);
		}
	}
}



/*--------------------------------------------------------------*/
//ʱжϷ
void T0_intservice(void) interrupt 1   
{
    TH0  = 0x4b;
    TL0  = 0x06;

	count++;
	if(count == 20)
	{
		count = 0;
		second++;
		if(second == 60)
		{
			second = 0;
			minute++;
			if(minute == 60)
			{
				minute = 0;
				hour++;
				if(hour == 24)	hour = 0;
			}
		}
	}
}



/*--------------------------------------------------------------*/
//ʾ
void Display1(void)
{
	Write_MAX7221(Intensity, light);//16ȵ
	DisplayPD_MAX7221(8,   hour);	//ʾСʱ
	DisplayPD_MAX7221(5, minute);	//ʾ
	DisplayPD_MAX7221(2, second);	//ʾ
	DisplayP_MAX7221 (6, 10, 0);	//ʾ'-'
	DisplayP_MAX7221 (3, 10, 0);	//ʾ'-'
}



/*--------------------------------------------------------------*/
//ʾ
void Display2(void)
{
	DisplayPD_MAX7221(8,   hour);	//ʾСʱ
	DisplayPD_MAX7221(5, second);	//ʾ
	DisplayPD_MAX7221(2, minute);	//ʾ
	DisplayP_MAX7221 (6, 10, 0);	//ʾ'-'
	DisplayP_MAX7221 (3, 10, 0);	//ʾ'-'
}


/*--------------------------------------------------------------*/
//ʾ
void Display3(void)
{
	ClearRam_MAX7221(8);
	DisplayP_MAX7221 (6, 10, 0);	//ʾ'-'
	DisplayPD_MAX7221(5, second);	//ʾ
	DisplayP_MAX7221 (3, 10, 0);	//ʾ'-'
}


/*--------------------------------------------------------------*/
//
void Key_pro(void)
{
	static bit state1, state2;
	static unsigned char sk;

	if(k4 == 0)
	{
		delay();
		if(k4 == 0)
		{	
			light++;
			if(light == 16)		light = 0;
			sk++;
			if(sk == 5)	sk = 0;
			while(k4 == 0);
		}
	}
		
	if(sk == 0)
	{
		if(k1 == 0)
		{	
			delay();
			if(k1 == 0)
			{	
				second = 0;
				while(k1 == 0);	
			}
		}
		if(k2 == 0)
		{	
			delay();
			if(k2 == 0)
			{	
				minute++;
				if(minute == 60)	minute = 0;
				while(k2 == 0);
			}
		}
		if(k3 == 0)
		{		
			delay();
			if(k3 == 0)
			{		
				hour++;
				if(hour == 24)		hour = 0;	
				while(k3 == 0);	
			}				
		}
		Display1();
	}
		
	if(sk == 1)
	{
		if(k2 == 0)
		{
			delay();
			if(k2 == 0)
			{	
				state1 = ~state1;
				Write_MAX7221(Show_Power,  state1);
				while(k2 == 0);
			}
		}
		if(k3 == 0)
		{
			delay();
			if(k3 == 0)
			{	
				state2 = ~state2;
				Write_MAX7221(Show_Test,   state2);
				while(k3 == 0);
			}
		}
		Display1();				
	}

	if(sk == 2)	Display2();
	if(sk == 3)	DisplayAS8_MAX7221(tab);
	if(sk == 4) Display3();

}





/*--------------------------------------------------------------*/
//
void main(void)
{
	T0_init();
	Initial_MAX7221();
	while(1)
	{
		Key_pro();
	}
}